/* jshowmail.java by Manfred Haertel */

/* imports */

import java.util.* ;
import javax.mail.* ;

public class jshowmail
{
	public static void main ( String argv[] )
	{
		String host ;
		String protocol ;
		int port ;
		String user ;
		String password ;
		Properties properties ;
		Session session ;
		Store store = null ;
		Folder folder = null ;
		int numberofmessages = 0 ;
		int counter ;
		Message message ;
		Address[] from ;
		int x ;
		String subject ;
		Date date ;
		int size ;

		/* check number of arguments */

		if ( argv.length < 5 )
		{
			System.out.println ( "usage: java jshowmail <host> <protocol> <user> <password> <action>" ) ;
			System.exit ( 1 ) ;
		}

		/* check arguments */

		host = argv [0] ;
		protocol = argv [1] ;
		port = 110 ;
		user = argv [2] ;
		password = argv [3] ;

		/* only action show is implemented at the moment */

		if ( ! argv[4].equals ( "show" ) )
		{
			System.out.println ( "action " + argv [4] + " not implemented" ) ;
			System.exit ( 1 ) ;
		}

		/* announce ourselves */

		System.out.println ( "JSHOWMAIL V1.0 by Manfred Haertel" ) ;
		System.out.println ( "" ) ;

		/* initialize javamail */

		properties = System.getProperties () ;
		session = Session.getDefaultInstance ( properties , null ) ;

		try
		{
			store = session.getStore ( protocol ) ;
		}
		catch ( javax.mail.NoSuchProviderException exception )
		{
			System.out.println ( "could not get store." ) ;
			System.out.println ( exception.getMessage () ) ;
			System.exit ( 1 ) ;
		}

		try
		{
			store.connect ( host , port , user , password ) ;
		}
		catch ( javax.mail.MessagingException exception )
		{
			System.out.println ( "could not connect." ) ;
			System.out.println ( exception.getMessage () ) ;
			System.exit ( 1 ) ;
		}

		try
		{
			folder = store.getDefaultFolder () ;
		}
		catch ( javax.mail.MessagingException exception )
		{
			System.out.println ( "could not get default folder." ) ;
			System.out.println ( exception.getMessage () ) ;
			System.exit ( 1 ) ;
		}

		try
		{
			folder = folder.getFolder ( "INBOX" ) ;
		}
		catch ( javax.mail.MessagingException exception )
		{
			System.out.println ( "could not get folder." ) ;
			System.out.println ( exception.getMessage () ) ;
			System.exit ( 1 ) ;
		}

		try
		{
			folder.open ( Folder.READ_ONLY ) ;
		}
		catch ( javax.mail.MessagingException exception )
		{
			System.out.println ( "could not open folder." ) ;
			System.out.println ( exception.getMessage () ) ;
			System.exit ( 1 ) ;
		}

		/* get number of messages */

		try
		{
			numberofmessages = folder.getMessageCount () ;
		}
		catch ( javax.mail.MessagingException exception )
		{
			System.out.println ( "could not get number of messages." ) ;
			System.out.println ( exception.getMessage () ) ;
			System.exit ( 1 ) ;
		}

		System.out.println ( numberofmessages + " message(s) are waiting" ) ;

		/* get messages */

		for ( counter = 1 ; counter <= numberofmessages ; counter ++ )
		{
			System.out.println ( "" ) ;
			System.out.println ( "Message #" + counter + ":" ) ;
			try
			{
				message = folder.getMessage ( counter ) ;

				/* get and display infomations */

				from = message.getFrom() ;
				for ( x = 0 ; x < from.length ; x ++ )
					System.out.println ( "  From: " + from[x].toString () ) ;

				subject = message.getSubject () ;
				System.out.println ( "  Subject: " + subject ) ;

				date = message.getSentDate () ;
				System.out.println ( "  Date: " + date.toString () ) ;

				size = message.getSize () ;
				System.out.println ( "  Size: " + size + " bytes" ) ;
			}
                	catch ( javax.mail.MessagingException exception )
                	{
                        	System.out.println ( "could not get message " + counter ) ;
                        	System.out.println ( exception.getMessage () ) ;
	                }
		}
	}
}
